package com.ruoyi.ai.service.impl;

import java.util.List;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.SecurityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.ai.mapper.AiSampleAmountRecordMapper;
import com.ruoyi.ai.domain.AiSampleAmountRecord;
import com.ruoyi.ai.service.IAiSampleAmountRecordService;

/**
 * 体验金领取记录Service业务层处理
 * 
 * @author shi
 * @date 2025-11-13
 */
@Service
public class AiSampleAmountRecordServiceImpl implements IAiSampleAmountRecordService {

    @Autowired
    private AiSampleAmountRecordMapper aiSampleAmountRecordMapper;

    /**
     * 查询体验金领取记录
     * 
     * @param id 体验金领取记录主键
     * @return 体验金领取记录
     */
    @Override
    public AiSampleAmountRecord selectAiSampleAmountRecordById(Long id) {
        return aiSampleAmountRecordMapper.selectById(id);
    }

    /**
     * 查询体验金领取记录列表
     * 
     * @param aiSampleAmountRecord 体验金领取记录
     * @return 体验金领取记录
     */
    @Override
    public List<AiSampleAmountRecord> selectAiSampleAmountRecordList(AiSampleAmountRecord aiSampleAmountRecord) {
        return aiSampleAmountRecordMapper.selectAiSampleAmountRecordList(aiSampleAmountRecord);
    }

    /**
     * 分页查询体验金领取记录列表
     *
     * @param aiSampleAmountRecord 体验金领取记录
     * @return 体验金领取记录
     */
    @Override
    public IPage<AiSampleAmountRecord> selectAiSampleAmountRecordPage(Page page, AiSampleAmountRecord aiSampleAmountRecord) {
        LambdaQueryWrapper<AiSampleAmountRecord> query = Wrappers.lambdaQuery(aiSampleAmountRecord);
        query.eq(AiSampleAmountRecord::getDelFlag, "0");
        return aiSampleAmountRecordMapper.selectPage(page, query);
    }

    /**
     * 新增体验金领取记录
     * 
     * @param aiSampleAmountRecord 体验金领取记录
     * @return 结果
     */
    @Override
    public int insertAiSampleAmountRecord(AiSampleAmountRecord aiSampleAmountRecord) {
        aiSampleAmountRecord.setDelFlag("0");
        aiSampleAmountRecord.setCreateTime(DateUtils.getNowDate());
        return aiSampleAmountRecordMapper.insert(aiSampleAmountRecord);
    }

    /**
     * 修改体验金领取记录
     * 
     * @param aiSampleAmountRecord 体验金领取记录
     * @return 结果
     */
    @Override
    public int updateAiSampleAmountRecord(AiSampleAmountRecord aiSampleAmountRecord) {
//        aiSampleAmountRecord.setUpdateBy(SecurityUtils.getUsername());
        aiSampleAmountRecord.setUpdateTime(DateUtils.getNowDate());
        return aiSampleAmountRecordMapper.updateById(aiSampleAmountRecord);
    }

    /**
     * 批量删除体验金领取记录
     * 
     * @param ids 需要删除的体验金领取记录主键
     * @return 结果
     */
    @Override
    public int deleteAiSampleAmountRecordByIds(Long[] ids)
    {
        return aiSampleAmountRecordMapper.deleteAiSampleAmountRecordByIds(ids);
    }

    /**
     * 删除体验金领取记录信息
     * 
     * @param id 体验金领取记录主键
     * @return 结果
     */
    @Override
    public int deleteAiSampleAmountRecordById(Long id)
    {
        return aiSampleAmountRecordMapper.deleteAiSampleAmountRecordById(id);
    }

    @Override
    public AiSampleAmountRecord getAiSampleAmountRecordByUserId(String userId) {
        QueryWrapper<AiSampleAmountRecord> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("user_id", userId);
        return aiSampleAmountRecordMapper.selectOne(queryWrapper);
    }
}
